#if !defined camerascript_h
#define      camerascript_h

#include <string.h>
#include "main.h"
#include "place.h"

//--------------------------------------------------------------------------------

enum interptypes {BSPLINE,CATMULL};

#define MAXSCRIPTENTRIES 100

class CameraScript{
public:		CameraScript();
	virtual ~CameraScript();

	int nitems, itemn, record, play, type;
	float pos, lastEntryTime, interval, denom;
	float a0,a1,a2,a3;

	struct location{
		float x,y,z, pitch, heading, roll;
	} data[MAXSCRIPTENTRIES];

	void script2place(Place *place);
	void insert(Place *place, int force);
	int save(const char* title);
	int load(const char* title);
	void update(float increment);

	void  set_spline(float pos);
	void  set_catmull(float pos);
	float get(float v1, float v2, float v3, float v4);
};

//--------------------------------------------------------------------------------

#endif