//-----------------------------------------------------------------------------
//	dialog.c
//
//   my first full OOP class design, now seriously in need of rewrite
//   required features:
//      parallel & nested menus
//      draggable menus
//      buttons with on/selected indicators, activated on click-release
//      toggles with on/off indicators
//      sliders with:
//         friendly "while activated don't require remaining on the control" behaviour
//         control of float values with current value annotation
//
//   kluged-in features needing of better incorporation:
//      key-navigation: up/down to select, left/right to activate/toggle/adjust 1% or +-1
//      menu toggle w/ fade in & out & offscreen-onscreen motion
//      INT slider attribute [truncates annot and controls key increment]
//      LOG slider behaviour
//      BACK button type
//      label/annot positioning
//
//   make new widget in one command: control(TYPE,"Label",myID, initialValue[,min,max,float/int,log/lin])
//   process new widget in switch/case or if statement using currentMenuID & activeItemID
//
//   hierarchy: dialog containing widgets [button/toggle/slider/back/title]
//
//   needs: rewrite, lists vs. arrays, motion control, dvd-style graphics/animation
//
//--------------------------------------------------------------------------------------

#include "dialog.h"
#include "hardware.h"
#include "effect.h"

#define labelXOffset 150
#define valueXOffset 15
#define textshift 15

extern Effect effect;

//--------------------------------------------------------------------------------------

Widget::Widget() { size=10;	return; };
Widget::~Widget() {};

Texture *Widget::tex=0;    // font
int   Widget::textSize=10; // global label size
Text *Widget::text=0;      // text obj

//--------------------------------------------------------------------------------------

void Widget::init(char *s, int inID, int inindex, int intype,
		            float inx, float iny, float inwidth, float inheight,
						float invalue, float inmin, float inmax, int flag, int linear) {
	
	ID=inID;
	size=textSize;
	index=inindex;
	type=intype;
	x=inx;
	y=iny;
	width=inwidth;
	height=inheight;
	x2=x+width;
	y2=y+height;
	strcpy(label,s);
}

//------------------------------------------------------------

int Widget::inside(int mousex, int mousey, int ox, int oy) { // detect if in x & y bounds
	int flag=0;
	mousey=Hw::get()->screen.height-mousey;
	if ((mousex>=(x+ox))&&(mousex<=(x2+ox))) flag =1;
	if ((mousey>=(y+oy))&&(mousey<=(y2+oy))) flag|=2;
	return flag;
}

//--------------------------------------------------------------------------------------

void Widget::show(float ox,float oy, int current){	return; }

//--------------------------------------------------------------------------------------

int Widget::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {	return 0; }

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Slider::Slider() {
	linear=0;
	return;
};
Slider::~Slider() {};

float Slider::texX0=0; // describe portion of controls texture that has the widget image
float Slider::texY0=.75;
float Slider::texX1=.25;
float Slider::texY1=1;

//--------------------------------------------------------------------------------------

void Slider::init(char *s, int inID, int inindex, int intype,
		            float inx, float iny, float inwidth, float inheight,
						float invalue, float inmin, float inmax, int flag, int inlinear) {

	this->Widget::init(s, inID, inindex,intype,inx, iny, inwidth, inheight);

	truncate=flag;
	min=inmin;
	max=inmax;
	value=invalue;
	range=max-min;
	linear=inlinear;
}

//------------------------------------------------------------

void Slider::show(float ox,float oy, int current){
	float f,v;
	char s[80];

	f=(value-min) / range; // normalize
	if (!linear) f=sqrt(f); // log?
	v=(f*width); // slider pos
	drawQ(tex, x+ox,    y+oy+6, x2+ox,     y2+oy-6, texX0+.1 ,texY0, texX1-.1, texY1); // draw range
	drawQ(tex, x+ox+v-10,y+oy, x +ox+v+10, y2+oy,   texX0+.25,texY0, texX1+.25,texY1); // draw control
	if (truncate) sprintf(s,"%5d",(int)value);
	else          sprintf(s,"%5.2f",   value);

	text->print(label, x2+labelXOffset*textSize / 20.+ox, y+oy+textshift,textSize);
	text->print(s    , x2+valueXOffset               +ox, y+oy+textshift,textSize);
	return;
}

//--------------------------------------------------------------------------------------

int Slider::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {
	if (Hw::get()->mouse.button[0]) {
		switch(Hw::get()->mouse.button[0]) {
			float f;
		case 1:
			if (inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3) { // if in x&y on downstroke
				f=(Hw::get()->mouse.x-ox-x) / width;
				if (!linear) value=pow(f,2)*range+min;
				else         value=    f   *range+min;
				*outValue=value;
				return 1;
			}
			break;
		case 2:
			if ((inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)&1)&&current) { // if in x & still down
				f=(Hw::get()->mouse.x-ox-x) / width;
				if (!linear) value=pow(f,2)*range+min;
				else         value=    f   *range+min;
				*outValue=value;
				return 1;
			}
			break;
		}
	}
	if (Hw::get()->key.skey&&current) {
		if (Hw::get()->key.skey==GLUT_KEY_LEFT) { // left key adj
			if (truncate) value-=1;
				else value-=.01*range;
			if (value<min) value=min;
			*outValue=value;
			return 1;
		}
		if (Hw::get()->key.skey==GLUT_KEY_RIGHT) { // right key adj
			if (truncate) value+=1;
			else value+=.01*range;
			if (value>max) value=max;
			*outValue=value;
			return 1;
		}
	}
	return 0;
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Toggle::Toggle() {};
Toggle::~Toggle() {};

float Toggle::texX0=.5;
float Toggle::texY0=.75;
float Toggle::texX1=.75;
float Toggle::texY1=1;

//--------------------------------------------------------------------------------------

void Toggle::init(char *s, int inID, int inindex, int intype,
		      float inx, float iny, float inwidth, float inheight,
			   float invalue, float inmin, float inmax, int flag, int linear) {

	this->Widget::init(s, inID, inindex,intype, inx, iny, inwidth, inheight);
	on=invalue;
}

//---------------------------------------------------------------------------

void Toggle::show(float ox,float oy, int incurrent){
	float current=incurrent*.33+.66;
	if (on) {
		text->print("On",  x2+valueXOffset+ox, y+oy+textshift,textSize);
		glColor3f(.5*current*text->inten,1*current*text->inten,.5*current*text->inten);
	}
	else {
		text->print("Off", x2+valueXOffset+ox, y+oy+textshift,textSize);
		glColor3f(1*current*text->inten,.5*current*text->inten,.5*current*text->inten);
	}
	drawQ(tex, x+ox,y+oy, x2+ox,y2+oy, (on)?texX0+.25:texX0,texY0,
		                                (on)?texX1+.25:texX1,texY1);
	text->print(label, x2+(labelXOffset)*textSize / 30.+20+ox, y+oy+textshift,textSize);
	return;
}

//--------------------------------------------------------------------------------------

int Toggle::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {
	if (Hw::get()->mouse.button[0]) {
		switch(Hw::get()->mouse.button[0]) {
		case 1:
			if (inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3) {
				on=!on;
				*outValue=on;
				return 1;
			}
			break;
		}
	}
	if ((Hw::get()->key.key||Hw::get()->key.skey)&&current) {
		if ((Hw::get()->key.key==13)||
			 (Hw::get()->key.skey==GLUT_KEY_LEFT)||(Hw::get()->key.skey==GLUT_KEY_RIGHT)) {
			on=!on;
			*outValue=on;
			return 1;
		}
	}
	return 0;
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Button::Button() {};
Button::~Button() {};

float Button::texX0=0;
float Button::texY0=.5;
float Button::texX1=.25;
float Button::texY1=.75;

//--------------------------------------------------------------------------------------

void Button::init(char *s, int inID, int inindex, int intype,
		      float inx, float iny, float inwidth, float inheight,
			   float invalue, float inmin, float inmax, int flag, int linear) {

	this->Widget::init(s, inID, inindex,intype,inx, iny, inwidth, inheight);
	on=0;
}

//--------------------------------------------------------------------------------------

void Button::show(float ox,float oy, int current){
	drawQ(tex, x+ox,y+oy, x2+ox,y2+oy,(on)?texX0+.25:texX0,texY0,
		                               (on)?texX1+.25:texX1,texY1);
	text->print(label, x2+valueXOffset+ox, y+oy+textshift,textSize);
	return;
}

//--------------------------------------------------------------------------------------

int Button::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {
	if (Hw::get()->mouse.button[0]) {
		switch(Hw::get()->mouse.button[0]) {
		case 1: if  (inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3) {on=1; return 2;}
		case 2: if (current) {
			if ((inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3)&&current) on=1;
			else on=0;
				  }
			break;
		case 3:
			if ((inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3)&&current) {
				on=1;
				return 1;
			}
			break;
		}
	}
	if ((Hw::get()->key.key||Hw::get()->key.skey)&&current) {
		if ((Hw::get()->key.key==13)||(Hw::get()->key.skey==GLUT_KEY_LEFT)||(Hw::get()->key.skey==GLUT_KEY_RIGHT)) {
			return 1;
		}
	}
	return 0;
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Back::Back() {};
Back::~Back() {};

float Back::texX0=0;
float Back::texY0=.25;
float Back::texX1=.25;
float Back::texY1=.5;

//--------------------------------------------------------------------------------------

void Back::init(char *s, int inID, int inindex, int intype,
		      float inx, float iny, float inwidth, float inheight,
			   float invalue, float inmin, float inmax, int flag, int linear) {

	this->Widget::init(s, inID, inindex,intype,inx, iny, inwidth, inheight);
	on=0;
}

//--------------------------------------------------------------------------------------

void Back::show(float ox,float oy, int current){
	drawQ(tex, x+ox,y+oy, x2+ox,y2+oy,(on)?texX0+.25:texX0,texY0,
		                               (on)?texX1+.25:texX1,texY1);
	text->print(label, x2+valueXOffset+ox, y+oy+textshift,textSize);
	return;
}

//--------------------------------------------------------------------------------------

int Back::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {
	if (Hw::get()->mouse.button[0]) {
		switch(Hw::get()->mouse.button[0]) {
		case 1: on=1; return 2;
		case 2: if ((inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)!=3)) on=0; else on=1;
			break;
		case 3:
			if ((inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3)&&current) return 1;
			break;
		}
	}
	if ((Hw::get()->key.key||Hw::get()->key.skey)&&current) {
		if ((Hw::get()->key.key==13)||(Hw::get()->key.skey==GLUT_KEY_LEFT)||(Hw::get()->key.skey==GLUT_KEY_RIGHT)) {
			return 1;
		}
	}
	return 0;
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Title::Title() {};
Title::~Title() {};

float Title::texX0=.5;
float Title::texY0=.5;
float Title::texX1=.75;
float Title::texY1=.75;

//--------------------------------------------------------------------------------------

void Title::init(char *s, int inID, int inindex, int intype,
		      float inx, float iny, float inwidth, float inheight,
			   float invalue, float inmin, float inmax, int flag, int linear) {
	
	this->Widget::init(s, inID, inindex,intype,inx, iny, inwidth, inheight);
}

//--------------------------------------------------------------------------------------

void Title::show(float ox,float oy, int current){
	drawQ(tex, x+ox,y+oy, x2+ox,y2+oy, texX0,texY0, texX1,texY1);
	if (textSize<=10) text->print(label, x2+valueXOffset+ox+70, y+oy+textshift,textSize*1.5);
	else              text->print(label, x2+valueXOffset+ox+70, y+oy+textshift,textSize  );
	return;
}

//--------------------------------------------------------------------------------------

int Title::process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current) {
	if (Hw::get()->mouse.button[0]) {
		switch(Hw::get()->mouse.button[0]) {
		case 1:
			if (inside(Hw::get()->mouse.x, Hw::get()->mouse.y, ox,oy)==3) {on=1; return 3;}
			break;
		case 2:
			if (current&&on) return 3;
			break;
		case 3:
			if (current) {on=0; return 3;}
			break;
		}
	}
	if (Hw::get()->key.skey&&current) {
		if ((Hw::get()->key.skey==GLUT_KEY_LEFT)   ||(Hw::get()->key.skey==GLUT_KEY_RIGHT)||
		    (Hw::get()->key.skey==GLUT_KEY_PAGE_UP)||(Hw::get()->key.skey==GLUT_KEY_PAGE_DOWN))  return 3;
	}
	return 0;
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

Dialog::Dialog() {
	ndialogPushed=0;
	for (int i=0; i<maxa; i++) controls[i]=0;
	clear();
	saveView=0;
	fadedir=0; fade=0;
	//mouse=0; key=0; 
	text=0;// time=0;
	refresh=0;
	ox=0; oy=0;
    dragx0=0;
	dragy0=0;
    dragx1=0;
	dragy1=0;
	lastox=0;
	lastoy=0;
	sliderWidth=140;
	sliderHeight=24;
	sliderYinc=-30;
	buttonWidth=30;
	buttonHeight=30;
	buttonYinc=-40;
	colorscale=1;
	coloroffset=1;
	return;
};

Dialog::~Dialog() {
	for (int i=0; i<maxa; i++) if (controls[i]) {delete controls[i]; controls[i]=0;}
};

//--------------------------------------------------------------------------------------

void Dialog::clear(void) {
	ID=-1;
	nitems=0;
	activeID=-1;
	currentIndex=0;
	activeValue=0;
	ox=0; oy=0;
	buttonYinc=-40;
	sliderYinc=-30;
	for (int i=0; i<maxa; i++) if (controls[i]!=0) {delete controls[i]; controls[i]=0;}
	return;
}

//--------------------------------------------------------------------------------------

int Dialog::control(int intype, char *inlabel, int inID,
						   float invalue, float inmin, float inmax, int flag, int linear) {
	int found=-1;

	for (int i=0; i<nitems; i++) {  // already defined?
		if (inID==controls[i]->ID) {
			found=i;
			break;
		}
	}
	if (found<0) {
		if (nitems<maxa) {  // if not, add
			found=nitems;
			nitems++;
		}
	}
	if (found<0) return found;
	switch(intype) {
	case SLIDER:
		if (controls[found]==0) controls[found]=new Slider;
		if (controls[found]==0) {nitems-=1; return -1;}
		controls[found]->init(inlabel,inID,found,SLIDER,x,y,sliderWidth,sliderHeight,invalue,inmin,inmax,flag, linear);
		y+=sliderYinc;
		break;

	case TOGGLE:
		if (controls[found]==0) controls[found]=new Toggle;
		if (controls[found]==0) {nitems-=1; return -1;}
		controls[found]->init(inlabel,inID,found,TOGGLE,x,y,buttonWidth,buttonHeight,invalue,0,0,0);
		y+=buttonYinc;
		break;

	case BUTTON:
		if (controls[found]==0) controls[found]=new Button;
		if (controls[found]==0) {nitems-=1; return -1;}
		controls[found]->init(inlabel,inID,found,BUTTON,x,y,buttonWidth,buttonHeight,0,0,0,0);
		y+=buttonYinc;
		break;

	case BACK:
		if (controls[found]==0) controls[found]=new Back;
		if (controls[found]==0) {nitems-=1; return -1;}
		controls[found]->init(inlabel,inID,found,BACK,x+50,y,buttonWidth,buttonHeight,0,0,0,0);
		y-=40;
		break;

	case TITLE:
		if (controls[found]==0) controls[found]=new Title;
		if (controls[found]==0) {nitems-=1; return -1;}
		controls[found]->init(inlabel,inID,found,TITLE, x,y,buttonWidth,buttonWidth,0,0,0,0);
		break;
	}
	if  (intype==TITLE) control(BACK,"", 93); // make a back button automatically next to the title

	return found;
}

//--------------------------------------------------------------------------------------

void Dialog::show(void) { // display all widgets
	float lox;

	if (fade!=fadedir) {
		fade+=Hw::get()->time.dt*3*(fadedir*2-1);
		fade=(fade<0)?0:(fade>1)?1:fade;
	}
	lox=ox;
	inten=fade;
	text->inten=inten;
	for (int i=0; i<nitems; i++) {
		if (i==currentIndex) glColor3f(    inten,    inten,    inten);
		else                 glColor3f(.75*inten,.75*inten,.75*inten);
		controls[i]->show(ox-300*pow(1-fade,2),oy, (currentIndex==i));
	}
	ox=lox;
	return;
}

//--------------------------------------------------------------------------

void Dialog::check(void) { // check all widgets for contact/activation
	float value=0;
	int status=0;
	
	activeID=-1;
	activeValue=0;
	for (int i=0; i<nitems; i++) {
		status=controls[i]->process(&Hw::get()->key, &Hw::get()->mouse, ox, oy, &value, (currentIndex==i));
		if (status) {
			if (Hw::get()->mouse.button[0]==1) currentIndex=i;
			if (status==1) {
				activeID=controls[i]->ID;
				activeValue=value;
				return;
			}
			if (status==3) {
				switch(Hw::get()->mouse.button[0]) {
				case 1:
					dragx0=Hw::get()->mouse.x;
					dragy0=Hw::get()->screen.height-Hw::get()->mouse.y;
					break;
				case 2:
					dragx1=Hw::get()->mouse.x;
					dragy1=Hw::get()->screen.height-Hw::get()->mouse.y;
					ox=lastox+dragx1-dragx0;
					oy=lastoy+dragy1-dragy0;
					break;
				case 3:
					lastox=ox;
					lastoy=oy;
					break;
				}
			break;
			}
		}
	}
	return;
}

//----------------------------------------------------------------------------

void Dialog::service(void) { // do menu
	if (Hw::get()->key.skey==GLUT_KEY_UP)
		currentIndex=(currentIndex==0)?nitems-1:currentIndex-1;

	if ((Hw::get()->key.key==9)||(Hw::get()->key.skey==GLUT_KEY_DOWN))
		currentIndex=(currentIndex>=(nitems-1))? 0: currentIndex+1;

	show();
	check();
	return;
}

//--------------------------------------------------------------------------------------

void Dialog::init(int ID, int inpush) {
	float cox=ox;
	float coy=oy;
	if (inpush) push();
	dialog_init(ID,1);
	ox=cox;
	oy=coy;
	return;
}

//--------------------------------------------------------------------

void Dialog::push(void) { // save current menuID
	if (ndialogPushed<maxDialogDepth) dialogStack[ndialogPushed++]=ID;
	else log_message("** Attempt to push dialog beyond limits");
	return;
}

//--------------------------------------------------------------------

void Dialog::pop(void) { // restore previous menuID
	if (ndialogPushed>0) {
		dialog_init(dialogStack[--ndialogPushed],1);
	} else log_message("** Attempt to pop no dialog");
	return;
}

//--------------------------------------------------------------------

void Dialog::run(void) {
	service();
	if (activeID > -1) dialog_do();
}

//--------------------------------------------------------------------
//--------------------------------------------------------------------

void drawQ(Texture *tex, float x, float y, float x2, float y2,
			  float texX0,float texY0, float texX1, float texY1) { // draw a single widget element
	glAlphaFunc(GL_GREATER,.095);
	glEnable(GL_ALPHA_TEST);
	if (tex) {
		glEnable(GL_TEXTURE_2D);
		tex->bind();
	}
	glPushAttrib(GL_POLYGON_MODE);
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
		glBegin(GL_QUADS);
			glTexCoord2f(texX0,texY0); glVertex2f(x ,y);
			glTexCoord2f(texX1,texY0); glVertex2f(x2,y);
			glTexCoord2f(texX1,texY1); glVertex2f(x2,y2);
			glTexCoord2f(texX0,texY1); glVertex2f(x ,y2);
			glEnd();
		glPopAttrib();
	glDisable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);
	if (tex) glDisable(GL_TEXTURE_2D);
	return;
}

//--------------------------------------------------------------------------------

void Dialog::dialog_init_standard(int inID, int mode) { // setup standard framework menu
	Hw *hw=Hw::get();
	char s[80];

	Widget::textSize=10;
	switch(ID) {
	//----------------------------------------------------------------
	case CAMERA:
	sliderYinc=-28;
	control(TITLE, "Camera", 0);
	y-=10;
	control(SLIDER,"v ViewCamMode",601, hw->screen.viewports[hw->screen.currentViewport].camera.place.movemode,0,4.9,1,1);
	y-=10;
	control(SLIDER,",. Camera Field Of View Degrees",51, hw->screen.viewport->camera.fov,                 5,        178, 1,1);
	y-=10;
	control(SLIDER,"   CameraX", 5211, hw->screen.viewports[hw->screen.currentViewport].camera.eyex,-.3*hw->worldSize,.3*hw->worldSize, 0,1);
	control(SLIDER,"   CameraY",  521, hw->screen.viewports[hw->screen.currentViewport].camera.eyey,-.3*hw->worldSize,.3*hw->worldSize, 0,1);
	control(SLIDER,"{} CameraZ",   52, hw->screen.viewports[hw->screen.currentViewport].camera.eyez,-.3*hw->worldSize,.3*hw->worldSize, 0,1);
	y-=15;
	control(SLIDER,"-= Camera Orbit RotateSpeed", 56,  hw->pref.spd1,  0,20);
	control(SLIDER,"_+ Camera Orbit Move Speed",  57,  hw->pref.spd2,  0,20);
	y-=10;
	break;
	//control(SLIDER,"v ViewCam Movement Mode",  601, saveView,  0,  3.8, 1,1);
	//---------------------------------------------------------------------
	case OBJECT:
	sliderYinc=-22;

	if (effect.dispman.selObject==0) {
	control(TITLE, "Edit Object - ", 0);
		hw->ann->hold("No object selected ('e')");
		return;
	}
	strcpy(s,"Edit Object: ");
	strcat(s,effect.dispman.dos[effect.dispman.selObject-1].label);
	control(TITLE, s, 0);
	y-=10;
	control(SLIDER,"e Edit object",1000, effect.dispman.selObject, 0,effect.dispman.nobjects+.9, 1,1);
	y-=5;
	control(SLIDER,"Red",           20, hw->pref.r,  0,1, 0,1);
	control(SLIDER,"Green",         21, hw->pref.g,  0,1, 0,1);
	control(SLIDER,"Blue",          22, hw->pref.b,  0,1, 0,1);
	control(SLIDER,"Alpha",         23, hw->pref.a,  0,1, 0,1);
	control(SLIDER,"Color Scale",   24, colorscale,.01,2, 0,1);
	control(SLIDER,"Color Offset",  25, coloroffset,.01,2, 0,1);
	y-=5;
	if (effect.dispman.dos[effect.dispman.selObject-1].vis.alphatest)
		control(SLIDER,"AlphaFuncValue",411,hw->pref.alphafunc, 0,1);
	if (effect.dispman.dos[effect.dispman.selObject-1].vis.blend) {
		control(SLIDER,"b BlendFunc0",  31, hw->pref.blendFunc0, 0,8.5, 1,1);
		control(SLIDER,"B BlendFunc1",  32, hw->pref.blendFunc1, 0,7.5, 1,1);
		y-=5;
	}
	if (effect.dispman.dos[effect.dispman.selObject-1].vis.ntexlayers)
		control(SLIDER,"Texture layer", 311, hw->pref.seltexlayer, 0,effect.dispman.dos[effect.dispman.selObject-1].vis.ntexlayers+.5, 1,1);
	if (effect.dispman.dos[effect.dispman.selObject-1].texattribs[0].textures) {
		control(SLIDER,"i Image Textures",39, hw->pref.image, 0,Texture::ntextures-.1, 1,1);
		control(SLIDER,"Texture X Scale",   40, hw->pref.texmagx, 0,80);
		control(SLIDER,"Texture Y Scale",   41, hw->pref.texmagy, 0,80);
		control(SLIDER,"Texture X Offset",  42, hw->pref.texoffx, 0,.25);
		control(SLIDER,"Texture Y Offset",  43, hw->pref.texoffy, 0,.25);
		y-=5;
	}
	//control(SLIDER,"Texture BlendFunc0", 301, hw->pref.texBlendFunc0, 0,8.5, 1,1);
	//control(SLIDER,"Texture BlendFunc1", 302, hw->pref.texBlendFunc1, 0,7.5, 1,1);
	if ((effect.dispman.dos[effect.dispman.selObject-1].material.on!=0)&&(hw->pref.lights!=0)) {
		control(SLIDER,"Material Ambient",    10, hw->pref.ambient,    0,1, 0,1);
		control(SLIDER,"Material Diffuse",    11, hw->pref.diffuse,    0,1, 0,1);
		control(SLIDER,"Material Specular",   12, hw->pref.specular,   0,1, 0,1);
		control(SLIDER,"Material Reflective", 13, hw->pref.reflective, 0,1, 0,1);
		control(SLIDER,"Material Shininess",  14, hw->pref.shininess,  0, 128, 1,1);
		control(SLIDER,"Material Cutoff",     15, hw->pref.cutoff,     0, 180, 1,1);
		control(SLIDER,"Material Exponent",   16, hw->pref.exponent,   0,  10, 1); 
		y-=5;
		control(SLIDER,"Material Red",       200, hw->pref.mat_r,      0,1, 0,1);
		control(SLIDER,"Material Green",     201, hw->pref.mat_g,      0,1, 0,1);
		control(SLIDER,"Material Blue",      202, hw->pref.mat_b,      0,1, 0,1);
		y-=5;
	}
	break;
	//--------------------------------------------------------------------------------------
	case GENERAL:
	sliderYinc=-24;
	control(TITLE, "Misc", 0);
	y-=10;
	//control(SLIDER,"u Universe: None/Stars/Particles/FixedSkyBox/MovableSkyBox",42, hw->pref.universe, 0,11.9, 1,1);
	control(SLIDER,"u Universe: None/Stars",42, hw->pref.universe, 0,1.9, 1,1);
	x+=40;
	y-=10;
	control(TOGGLE,"d Fog DepthCue",281, hw->pref.fog);
	x-=40;
	y+=5;
	control(SLIDER,"F5/F6 Fog Start Distance", 28, hw->pref.b1, 0,5*hw->worldSize,1,0);
	control(SLIDER,"F7/F8 Fog End Distance",   29, hw->pref.b2, 0,5*hw->worldSize,1,0);
	y-=5;
	control(SLIDER,"W PolygonMode",       58, hw->pref.wireframe,  0,  2.9, 1,1);
	y-=5;
	control(SLIDER,"Mouse Sensitivity",                 71,hw->pref.mouseSens, 0,2, 0,1);
	control(SLIDER,"ArrowMove/Click Thrust Sensitivity",72,hw->pref.moveSens,  0,5, 0,1);
	control(SLIDER,"DoubleClick Interval",           1002, hw->pref.doubleClickInterval,.1,1);
	control(SLIDER,"Spurt X",                        1003, hw->pref.spurt, 1,1000,1,0);
	control(SLIDER,"Gravity Scaler",                 1000, hw->pref.gravityScaler,.1,10);
	control(SLIDER,"Drag Scaler",                    1001, hw->pref.dragScaler,   .1,10);
	y-=5;
	control(SLIDER,"n Numeric Item",101, hw->pref.n, 0,maxn+.9, 1,1);
	x+=40;
	y-=15;
	control(TOGGLE, "c FPS Clock", 100, hw->pref.clock);
	control(TOGGLE, "U User Mode", 103, hw->pref.user);
	control(TOGGLE, "I Scrolling Info/Hints", 102, hw->pref.scrollInfo);
	x-=40;
	control(SLIDER,"Scroll Speed",104,hw->pref.scrollSpeed,  .2,3, 0,1);
	control(SLIDER,"Scroll Interval",105,hw->pref.scrollInterval,  10,200, 1,1);
	x+=40;
	y-=5;
	control(BUTTON, "Reset/Randomize",  999);

	break;
	//---------------------------------------------------------------------------------------
	case LIGHTING:
	sliderYinc=-28;
	control(TITLE, "Lighting", 0);
	x+=40;
	y-=10;
	control(TOGGLE, "s SpotLighting",501, hw->pref.lights);
	x-=40;
	y-=10;
	break;
	//---------------------------------------------------------------------------------------
	/*
	case LIGHTMAP:
	sliderYinc=-28;
	y-=10;	
	control(TITLE, "Lightmap", 0);
	control(SLIDER,"Home/End:Lightmap Noise Level",60,  hw->pref.home,       0,50, 1,0);
	control(SLIDER,"F9/F10 Vignette Size",         73,  hw->pref.c1,         0,3,  0,1);
	control(SLIDER,"Lightmap Refresh Interval",    74,  hw->pref.lmInterval, 0,1);
	y-=15;	
	control(SLIDER,"Texture X Magnification",30,  hw->pref.lmtexmagx, 0,20);
	control(SLIDER,"Texture Y Magnification",31,  hw->pref.lmtexmagy, 0,20);
	y-=20;
	control(SLIDER,"Lightmaps: None/Vignette/Noise/Grating Combinations",61, abs(hw->pref.lightmap), 0,63.9, 1,1); y-=20;
	x+=40; 
	control(TOGGLE, "Film Noise",    21, hw->pref.lightmap&1);
	control(TOGGLE, "TV Line Noise", 22, hw->pref.lightmap&2);
	control(TOGGLE, "Z Pixel Noise", 23, hw->pref.lightmap&4);
	control(TOGGLE, "Vignette",      24, hw->pref.lightmap&8);
	control(TOGGLE, "X Grating",     25, hw->pref.lightmap&16);
	control(TOGGLE, "Y Grating",     26, hw->pref.lightmap&32);
	break;
	*/
	//----------------------------------------------------------------------------------------
	case MAIN:
	Widget::textSize=20; text->bend=1; text->alphatest=1;
	control(TITLE, "Main Menu", 0);
	x+=20;
	y-=10;
	control(BUTTON, "Options...",    3);
	y-=15;
	control(BUTTON, "Quit",         99);
	break;
	//control(BUTTON, "Save...",       1);
	//control(BUTTON, "Load...",       2);
	//----------------------------------------------------------------------------------------
	case OPTIONS:
	Widget::textSize=20; text->bend=1; text->alphatest=1;
	control(TITLE, "Options", 0);
	x+=20;
	y-=10;
	//text->bend=0; 
	control(BUTTON, "This...",  1);
	control(BUTTON, "Camera...",   9);
	control(BUTTON, "Edit Object...", 2);
	control(BUTTON, "Lighting...", 3);
	control(BUTTON, "Screen...",   8);
	control(BUTTON, "Sound...",   4);
	control(BUTTON, "Misc...", 7);
	break;
	//control(BUTTON, "FullScreen Lightmaps...", 5);
	//control(BUTTON, "Randoms...", 6);
	//-----------------------------------------------------------------------------------------
	/*
	case RANDOMS:
	sliderYinc=-28;
	control(TITLE, "Randoms", 0);
	x+=40;
	y-=10;
	control(TOGGLE,"User Mode Master Control (User vs. Computer control)",30, hw->pref.user);
	y-=15;
	control(TOGGLE,"Screen Splinter Effect",        210, hw->pref.splinterEnable);
	y-=5; 
	control(TOGGLE,"Show Splinter AND Main Render", 212, hw->pref.splinterPlus);
	x-=40;
	control(SLIDER,"Minimum Splinter Interval Secs",211, hw->pref.splinterMinInterval, 5,100, 1);
	x+=40;
	y-=25;
	control(TOGGLE,"FullScreen LightMaps",          220, hw->pref.lmEnable);
	x-=40;
	control(SLIDER,"Minimum LightMap Interval Secs",221, hw->pref.lmMinInterval, 2,100, 1);
	y-=25;
	x+=40;
	control(TOGGLE, "Horizontal/Vertical Skip",   230, hw->pref.skipEnable);
	x-=40;
	control(SLIDER,"Minimum Skip Interval Secs",  231, hw->pref.skipMinInterval, 2,100, 1);
	break;
	*/
	//---------------------------------------------------------------------------------------
	case SCREEN:
	sliderYinc=-28;
	control(TITLE, "Screen", 0);
	y-=10;
	control(SLIDER,"l Letterbox",           59, hw->pref.letterbox,  0,  .49, 0,0);
	y-=10;
	control(SLIDER,"F11/F12 Screen Fade Effect", 55, hw->pref.c2,       .01,    1);
	x+=40;
	y-=20;
	control(TOGGLE, "<SPACE> Blanking",96, hw->pref.blank);
	break;
	//---------------------------------------------------------------------------
	case SOUND:
	sliderYinc=-28;
	control(TITLE, "Sounds", 0);
	x+=40;
	y-=10;
	control(TOGGLE,"Sounds",     70, hw->sound.on);
	x-=40;
	y-=5;
	control(SLIDER,"MasterSoundVolume", 71, hw->sound.volume_master, 0,1, 0,1);
	y-=15;
	control(SLIDER,"Rolloff Factor",       713, hw->sound.rolloff, 0,10, 0,0);
	y-=15;
	control(SLIDER,"Ambient Volume",714,    hw->pref.ambientvolume, 0,1, 0,1);
	y-=15;
	control(SLIDER,"Song Volume",7141,    hw->pref.songvolume, 0,1, 0,1);
	y-=15;
	//control(SLIDER,"Step Volume",      108, hw->pref.stepVolume, 0, 1, 0,1);
	//control(SLIDER,"Step Pan",         109, hw->pref.stepPan,    0,.5, 0,1);

	break;
	//if (hw->sound.mod) {
	//	 y-=40;
		 //x+=40; control(TOGGLE,"Music",      702, hw->sound.on_music);
	//y-=5;
		//x-=40; control(SLIDER,"MusicVolume",712, hw->sound.volume_music,  0,1, 0,1);
	//}
	//control(SLIDER,"Minimum Distance",     714, hw->sound.mindistance, 0,100, 0,0);
	//control(SLIDER,"Maximum Distance",     715, hw->sound.maxdistance, 0,100, 0,0);
	//---------------------------------------------------------------------------------------
	case SAVE:
	Widget::textSize=20; text->bend=1; text->alphatest=1;
	control(TITLE,"Save Menu", 0);
	y-=10;
	control(BUTTON,"! Save Prefs", 1);
	break;
	//---------------------------------------------------------------------------------------
	case LOAD:
	Widget::textSize=20; text->bend=1; text->alphatest=1;
	control(TITLE,"Load Menu", 0);
	y-=10;
	control(BUTTON,"@ Load Prefs",1);
	break;
	}
	return;
}

//-----------------------------------------------------------------------------

void Dialog::dialog_do_standard(void) {
	static float last0=0,last1=0, last2=0,last3=0;
	float value=activeValue;
	static int paused=0;
	Hw *hw=Hw::get();
	Camera &camera=hw->screen.viewports[hw->screen.currentViewport].camera;

	switch(ID) {
	case CAMERA:
	switch(activeID) {
		case 51: hw->screen.viewport->camera.fov=value;    hw->ann->hold("Fov: %4.2f Degrees",hw->screen.viewport->camera.fov); break;
		case 52: 
			hw->screen.viewports[hw->screen.currentViewport].camera.eyez=value;
			hw->ann->hold("CameraZ: %4.2f",value);	break;
		case 521:
			hw->screen.viewports[hw->screen.currentViewport].camera.eyey=value;
			hw->ann->hold("CameraY: %4.2f",value); break;
		case 5211:
			hw->screen.viewports[hw->screen.currentViewport].camera.eyex=value;
			hw->ann->hold("CameraX: %4.2f",value); break;
		case 56: hw->pref.spd1=value;   hw->ann->hold("Move Speed: %4.2f",value);  break;
		case 57: hw->pref.spd2=value;   hw->ann->hold("Rotate Speed: %4.2f",value);break;

		case 601:
			camera.place.movemode=value;
			switch(camera.place.movemode) {
				case HOLD:
					camera.lastmanpos   =camera.place.pos;
					camera.lastmanorient=camera.place.orient;
					hw->ann->hold("Hold");
					break;
				case ORBIT:  hw->ann->hold("Random/Orbit Pos & Orient"); break;
				case LOOKAT: hw->ann->hold("Look at..."); break;
				case LOOKFROM:
					if (camera.place.otherPlace!=0) hw->ann->hold("Look from...");
					else {
						camera.place.movemode=MANUAL;
						camera.place.pos   =camera.lastmanpos;
						camera.place.orient=camera.lastmanorient;
						hw->ann->hold("Manual ArrowKey/Mouse Control");
					}
					break;
				case MANUAL:
					camera.place.pos   =camera.lastmanpos;
					camera.place.orient=camera.lastmanorient;
					hw->ann->hold("Manual ArrowKey/Mouse Control");
					break;
			}
			break;
	}
	break;
/*
		case 601: saveView=value;
				switch(saveView) {
					case 0:	hw->ann->hold("Camera 0: Auto: Random Location and Orientation"); break;
					case 1:	hw->ann->hold("Camera 1: Manual: Mouse/Arrow Key Control");        hw->mouse->moved=1; break;
					case 2:	hw->ann->hold("Camera 2: Hold");                                   hw->mouse->moved=1; break;
					case 3:	hw->ann->hold("Camera 3: Auto: Random Location w/ Centered View"); hw->mouse->moved=1; break;
				}
				break;
*/
		//case 5211: hw->camera->centerx=value; hw->ann->hold("CameraX: %4.2f",value); break;
	//---------------------------------------------------------------------
	case OBJECT:
	switch(activeID) {
		case 411: hw->pref.alphafunc=value; hw->ann->hold("AlphaFuncValue: %4.2f",value); break;
		case 20: hw->pref.r=value;  hw->ann->hold("Red: %4.2f",value); break;
		case 21: hw->pref.g=value;  hw->ann->hold("Green: %4.2f",value); break;
		case 22: hw->pref.b=value;  hw->ann->hold("Blue: %4.2f",value); break;
		case 23: hw->pref.a=value;  hw->ann->hold("Alpha: %4.2f",value); break;
		case 24: colorscale=value;// color scale
			hw->pref.r*=(value / last0);
			hw->pref.g*=(value / last0);
			hw->pref.b*=(value / last0);
			if (hw->pref.r>1) hw->pref.r=1;
			if (hw->pref.g>1) hw->pref.g=1;
			if (hw->pref.b>1) hw->pref.b=1;
			last0=value;
			if (refresh<1) refresh=1;
			break;
		case 25: coloroffset=value;// color offset
			hw->pref.r+=(value-last1);
			hw->pref.g+=(value-last1);
			hw->pref.b+=(value-last1);
			hw->pref.r=(hw->pref.r>1)?1:(hw->pref.r<0)?0:hw->pref.r;
			hw->pref.g=(hw->pref.g>1)?1:(hw->pref.g<0)?0:hw->pref.g;
			hw->pref.b=(hw->pref.b>1)?1:(hw->pref.b<0)?0:hw->pref.b;
			last1=value;
			if (refresh<1) refresh=1;
			break;
		case 31: 
			hw->pref.blendFunc0=value; 
			hw->ann->hold(doc_blend());
			break;
		case 32: 
			hw->pref.blendFunc1=value; 
			hw->ann->hold(doc_blend());
			break;

		case 40: hw->pref.texmagx=value; hw->ann->hold("Texture X Scale: %4.2f",value); break;
		case 41: hw->pref.texmagy=value; hw->ann->hold("Texture Y Scale: %4.2f",value); break;
		case 42: hw->pref.texoffx=value; hw->ann->hold("Texture X Offset: %4.2f",value); break;
		case 43: hw->pref.texoffy=value; hw->ann->hold("Texture Y Offset: %4.2f",value); break;
		case 301: 
			hw->pref.texBlendFunc0=value; 
			hw->ann->hold(doc_blend());
			break;
		case 302: 
			hw->pref.texBlendFunc1=value; 
			hw->ann->hold(doc_blend());
			break;

		case 10: hw->pref.ambient=value;    hw->ann->hold("Material Ambient: %4.2f",value); break;
		case 11: hw->pref.diffuse=value;    hw->ann->hold("Material Diffuse: %4.2f",value); break;
		case 12: hw->pref.specular=value;   hw->ann->hold("Material Specular: %4.2f",value); break;
		case 13: hw->pref.reflective=value; hw->ann->hold("Material Reflective: %4.2f",value); break;
		case 14: hw->pref.shininess=value;  hw->ann->hold("Material Shininess: %4.2f",value); break;
		case 15: hw->pref.cutoff=value;     hw->ann->hold("Material Cutoff: %4.2f",value); break;
		case 16: hw->pref.exponent=value;   hw->ann->hold("Material Exponent: %4.2f",value); break;

		case 200: hw->pref.mat_r=value;  hw->ann->hold("Material Red: %4.2f",value); break;
		case 201: hw->pref.mat_g=value;  hw->ann->hold("Material Green: %4.2f",value); break;
		case 202: hw->pref.mat_b=value;  hw->ann->hold("Material Blue: %4.2f",value); break;
	}
	break;
	//--------------------------------------------------------
	case GENERAL:
	switch(activeID) {

		case 281: hw->pref.fog = 1-hw->pref.fog;
			hw->ann->hold_multi(hw->pref.fog,"Fog Off","Fog On");
			break;

		case 28: 
			hw->pref.b1=value;
			hw->ann->hold("Fog Start Distance: %4.2f", value);
			if (hw->pref.b2<hw->pref.b1+.01) {
				hw->pref.b2=hw->pref.b1+.01;
				if (refresh<1) refresh=1;
			}
			hw->pref.fog=1;
			break;
		case 29:
			hw->pref.b2=value;
			hw->ann->hold("Fog End Distance: %4.2f",   hw->pref.b2);
			if (hw->pref.b2<hw->pref.b1+.01) {
				hw->pref.b1=hw->pref.b2-.01;
				if (refresh<1) refresh=1;
			}
			hw->pref.fog=1;
			break;
		case 42: hw->pref.universe=value; hw->ann->hold(doc_universe()); break;
		case 56: hw->pref.spd1=value;   hw->ann->hold("Move Speed: %4.2f",value);  break;
		case 57: hw->pref.spd2=value;   hw->ann->hold("Rotate Speed: %4.2f",value);break;
		case 58: hw->pref.wireframe=value;
			hw->ann->hold_multi(hw->pref.wireframe,"Polygons","Lines","Points");
			break;
		case 60: hw->pref.home=value;   hw->ann->hold("Home: %4.2f",value);
			break;
		case 71: hw->pref.mouseSens=value; hw->ann->hold("Mouse Sensitivity: %4.2f",value); break;
		case 72: hw->pref.moveSens =value; hw->ann->hold("Move Sensitivity: %4.2f",value);  break;

		case 1002: hw->pref.doubleClickInterval=value; hw->ann->hold("DoubleClick Interval: %4.2f",value); break;
		case 1003: hw->pref.spurt              =value; hw->ann->hold("Spurt X: %4.2f",             value); break;
		case 1000: hw->pref.gravityScaler      =value; hw->ann->hold("Gravity Scaler: %4.2f",value); break;
		case 1001: hw->pref.dragScaler         =value; hw->ann->hold(   "Drag Scaler: %4.2f",value); break;

		case 100: hw->pref.clock=value; break;
		case 101: hw->pref.n    =value; hw->ann->hold("Numeric Item: %d",(int)value);  break;
		case 102: hw->pref.scrollInfo=value; hw->ann->hold_multi((int)value,"Hints Off","Hints On"); break;
		case 103: hw->pref.user      =value; hw->ann->hold_multi((int)value,"User Off: random effects","User On: no random effects"); break;
		case 104: hw->pref.scrollSpeed   =value; hw->ann->hold("Scroll Speed: %4.2f",value);  break;
		case 105: hw->pref.scrollInterval=value; hw->ann->hold("Scroll Interval: %4.2f",value);  break;
	}
	break;
	//---------------------------------------------------------------------
	case LIGHTING:
	switch(activeID) {
		case 501: hw->pref.lights=value;
			hw->ann->hold_multi(hw->pref.lights,"Lights On","Lights Off");
			//refresh=2;
			break;
	}
	break;
	//------------------------------------------------------------------------------
	/*
	case LIGHTMAP:
	switch(activeID) {
		case 60: hw->pref.home=value;    hw->ann->hold("Home: %4.2f",hw->pref.home);    break;
		case 61: hw->pref.lightmap=value;// lightmap.doc();
			if (refresh<1) refresh=1; break;
		case 73: hw->pref.c1   =value; hw->ann->hold("F9/F10: Vignette Size %5.1f",value); break;
		case 74: hw->pref.lmInterval=value; hw->ann->hold("Lightmap Refresh Interval:%5.1f secs",value); break;

		case 30: hw->pref.lmtexmagx=value; hw->ann->hold("Texture X Magnification: %4.2f",value);break;
		case 31: hw->pref.lmtexmagy=value; hw->ann->hold("Texture Y Magnification: %4.2f",value);break;

		case 21: if (value) hw->pref.lightmap|=1;
			else hw->pref.lightmap&=(63-1);
			if (refresh<1) refresh=1; break;
		case 22: if (value) hw->pref.lightmap|=2;
			else hw->pref.lightmap&=(63-2);
			if (refresh<1) refresh=1; break;
		case 23: if (value) hw->pref.lightmap|=4;
			else hw->pref.lightmap&=(63-4);
			if (refresh<1) refresh=1; break;
		case 24:
			if (value) {
				hw->pref.lightmap|=8;
				hw->pref.lmtexmagx=1;
				hw->pref.lmtexmagy=1;
			}
			else hw->pref.lightmap&=(63-8);
			if (refresh<1) refresh=1;
			break;
		case 25: if (value) hw->pref.lightmap|=16;
			else hw->pref.lightmap&=(63-16);
			if (refresh<1) refresh=1; break;
		case 26: if (value) hw->pref.lightmap|=32;
			else hw->pref.lightmap&=(63-32);
			if (refresh<1) refresh=1; break;
	}
	break;
	*/
	//----------------------------------------------------------------------------
	case MAIN:
	switch(activeID) {
		case 3: init(OPTIONS,1); break;
		case 1: init(SAVE,1); break;
		case 2: init(LOAD,1); break;
	}
	break;
	//---------------------------------------------------------------------
	case OPTIONS:
	switch(activeID) {
		case 1: init(THISAPP,1); break;
		case 2: init(OBJECT,1); break;
		case 3: init(LIGHTING,1); break;
		case 4: init(SOUND,1); break;
		case 8: init(SCREEN,1); break;
		case 9: init(CAMERA,1); break;
		case 7: init(GENERAL,1); break;
	}
	break;
		//case 5: init(LIGHTMAP,1); break;
		//case 6: init(RANDOMS,1); break;
	//---------------------------------------------------------------------
	/*
	case RANDOMS:
	switch(activeID) {
		case 210: hw->pref.splinterEnable=!hw->pref.splinterEnable;
			if (hw->pref.splinterEnable) hw->ann->hold("Splinter Enabled");
			else                     hw->ann->hold("Splinter Disabled");
			break;
		case 211: hw->pref.splinterMinInterval=value;
			hw->ann->hold("Splinter Min Interval Secs: %4.2f",value);
			break;
		case 212: hw->pref.splinterPlus=value;
			if (hw->pref.splinterPlus) hw->ann->hold("Splinter Effect AND Main Render");
			else                   hw->ann->hold("Splinter Effect OR Main Render");
			break;

		case 220: hw->pref.lmEnable=!hw->pref.lmEnable;
			if (hw->pref.lmEnable) hw->ann->hold("Lightmaps Enabled");
			else               hw->ann->hold("Lightmaps Disabled");
			break;
		case 221: hw->pref.lmMinInterval=value;
			hw->ann->hold("LightMap Min Interval Secs: %4.2f",value);
			break;

		case 230: hw->pref.skipEnable=!hw->pref.skipEnable;
			if (hw->pref.skipEnable) hw->ann->hold("Skip is Enabled");
			else                 hw->ann->hold("Skip is Disabled");
			break;
		case 231: hw->pref.skipMinInterval=value;
			hw->ann->hold("Skip Min Interval Secs: %4.2f",value);
			break;

		case 30:
			hw->pref.user=!hw->pref.user;
			if (hw->pref.user) hw->ann->hold("User Mode On, NO computer-controlled random changes");
			else                hw->ann->hold("User Off, computer-controlled random changes allowed");
			break;
	}
	break;
*/
	//---------------------------------------------------------------------------
	case SCREEN:
	switch(activeID) {
		case 55:
			hw->pref.c2=value; hw->pref.blank=0;
			if (hw->pref.c2>=1) {
				hw->pref.c2=1;
				hw->pref.blank=1;
				hw->screen.needblank=hw->pref.blank;
			} else if (hw->pref.c2<.02) hw->pref.c2=0;
			hw->ann->hold("Fade: %4.2f",hw->pref.c2);
			break;
		case 59:
			hw->pref.letterbox=value;
			hw->ann->hold("Letterbox: %.2f",hw->pref.letterbox);
			hw->screen.doc_letterbox();
			break;
		case 96: hw->pref.blank=value; hw->screen.needblank=hw->pref.blank;
			if (hw->pref.blank) {
				//hw->pref.blendFunc0=3;
				//hw->pref.blendFunc1=1;
				//hw->ann->hold("Set blend to GL_ONE_MINUS_SRC_ALPHA,GL_ONE");
			} else {
				//hw->pref.blendFunc0=5;
				//hw->pref.blendFunc1=1;
			}
			break;
	}
	break;
	//-----------------------------------------------------------------------------
	case SOUND:
	switch(activeID) {
		case 70: paused=1-value; //hw->sound.on=value;
			hw->sound.set_pause(paused);
			break;
		case 71: case 72: case 73: case 711:
			if      (activeID==71)  hw->sound.set_master_volume(value);
			break;
		case 713: hw->sound.set_rolloff(value); hw->ann->hold("Sound Rolloff Factor: %4.2f",value); break;
		case 714: hw->pref.ambientvolume=value; hw->ann->hold("Ambient Volume: %4.2f",value); break;
		case 7141:hw->pref.songvolume=value;    hw->ann->hold("Song Volume: %4.2f",value); break;
		case 108: hw->pref.stepVolume =value;   hw->ann->hold("Step Volume: %4.2f",value); break;
		case 109: hw->pref.stepPan    =value;   hw->ann->hold("Step Pan: %4.2f",value); break;
	}
	break;
			//else if (activeID==72) {hw->sound.pan=value;	hw->sound->set_pan(value);}
	/*	case 702: hw->sound.on_music=value;
			if (hw->sound.on_music) hw->sound.play_music(hw->sound.mod);
			else hw->sound.stop_music(hw->sound.mod);
			break;
		case 712:
			hw->sound.set_music_volume(hw->sound.mod,value);
			break;*/
		//case 714: hw->sound.mindistance=value; hw->ann->hold("Rolloff Minimum Distance: %4.2f",value); break;
		//case 715: hw->sound.maxdistance=value; hw->ann->hold("Rolloff Maximum Distance: %4.2f",value); break;
	//-----------------------------------------------------------------------------
	case SAVE:
	switch(activeID) {
		case 1:
		  if (hw->pref.save(hw->title)) hw->ann->hold("Could NOT Save Prefs");
		  else                          hw->ann->hold("Saved Prefs");
			break;
	}
	break;
	//-----------------------------------------------------------------------------
	case LOAD:
	switch(activeID) {
		case 1:
			if (hw->pref.load(hw->title)) hw->ann->hold("Could NOT Load Prefs");
			else {
				hw->ann->hold("Loaded Prefs");
				hw->screen.needblank=1;
			}
			hw->pause=0;
			break;
	}
	break;
	}
	return;
}

//---------------------------------------------------------------------------------------

void Dialog::on(void) {
	Hw::get()->dialogs=1;
	Hw::get()->pause=1;
	Hw::get()->help=0;
	fadedir=1;
	Hw::get()->mouse.set_cursor();
}

//----------------------------------------------------------------------

void Dialog::off(void) {
	Hw::get()->dialogs=0;
	Hw::get()->pause=0;
	fadedir=0;
	Hw::get()->mouse.set_cursor();
}

//----------------------------------------------------------------------




