//
//  this apps menu layout and processing
//

void dialog_init(int ID, int mode) {
	static int logged=0, viewportset=1;

	dialog->refresh=0;
	if (!logged) { logged=1; log_message("Init Dialog..."); }
	dialogText.alphatest=0;
	dialogText.bend=0;

	dialog->x=30;
	dialog->y=.7*hw->screen.height;
	if (mode==1) { // init 1 vs. update 0
		dialog->clear();
		dialog->ID=ID;
	}
	if (dialog->ID!=THISAPP) {
		dialog->dialog_init_standard(ID, mode);
		return;
	}
	//-------------------------------------------------------------------------------------------------------
	Widget::textSize=10;
	switch(ID) {
		case THISAPP:
			//              name   label             ID   currVal  minVal maxVal truncate? log?
			dialog->sliderYinc=-22;
			dialog->control(TITLE, hw->title, 0);
			dialog->x+=40;
			dialog->y-=10;
			dialog->control(BUTTON, "% Step Scene",  200);

			dialog->y-=10;
			dialog->control(TOGGLE, "D Demo Sequencing",201, hw->pref.demosequence);

			dialog->x-=40;
			dialog->y-=10;
			dialog->control(SLIDER,"Ring Size",      300, hw->pref.value[0], .01,10);
			dialog->control(SLIDER,"Ring Thickness", 301, hw->pref.value[1], .01,10);
			dialog->control(SLIDER,"Ring Roundness", 302, hw->pref.value[2], .1,3);
			dialog->control(SLIDER,"Globe Size",     303, hw->pref.value[3], .01,10);
			dialog->control(SLIDER,"Ray Width",      304, hw->pref.value[4], .1,4);
			dialog->control(SLIDER,"Ray Grouping",   305, hw->pref.value[5], .1,10);
			dialog->control(SLIDER,"Ray Red",    306, hw->pref.value[6], .01,1);
			dialog->control(SLIDER,"Ray Green",    307, hw->pref.value[7], .01,1);
			dialog->control(SLIDER,"Ray Blue",    308, hw->pref.value[8], .01,1);
			dialog->control(SLIDER,"Falls Marble Red",   309, hw->pref.value[9],  0,1, 0,1);
			dialog->control(SLIDER,"Falls Marble Green", 310, hw->pref.value[10], 0,1, 0,1);
			dialog->control(SLIDER,"Falls Marble Blue",  311, hw->pref.value[11], 0,1, 0,1);

			//dialog->control(SLIDER,"Value 12 r",        312, hw->pref.value[12], 0,1, 0,1);
			//dialog->control(SLIDER,"Value 13 g",        313, hw->pref.value[13], 0,1, 0,1);
			//dialog->control(SLIDER,"Value 14 b",        314, hw->pref.value[14], 0,1, 0,1);
			//dialog->control(SLIDER,"Value 15 ",        315, hw->pref.value[15], .01,10);
			//dialog->control(SLIDER,"Value 16",        316, hw->pref.value[16], .01,10);
			//dialog->control(SLIDER,"Value 17",        317, hw->pref.value[17], 0,100);
			//dialog->control(SLIDER,"Value 18",        318, hw->pref.value[18], .01,10);
			//dialog->control(SLIDER,"Value 19",        319, hw->pref.value[19], .01,10);

			dialog->control(SLIDER,"<> Tesselation Factor",501, hw->pref.tessf, .1,10);
			dialog->control(SLIDER,"1-6 #Viewports",       207, hw->pref.viewportset, 1,6,1,1);
			dialog->control(SLIDER,"C ColorMode",          204, hw->pref.colorMode, 0,4.9, 1,1);
			dialog->y-=5;

#if defined haseffect
			dialog->control(SLIDER,"e Edit object",1000, effect.dispman.selObject, 0,effect.dispman.nobjects+.9, 1,1);
#endif

			if (maximage) {
				//dialog->control(SLIDER,"i Images: Edit Textures",40, hw->pref.image, 0,Texture::ntextures-.1, 1,1);
			}
			if (maxoption) {
				//dialog->control(SLIDER,"o Options: Ring Normals",    41, hw->pref.option, 0, maxoption+.9, 1,1);
			}
			break;
	}
}
			//dialog->control(SLIDER,"Grunt mps",    106, hw->pref.gruntMPS,1,100);
			//dialog->control(SLIDER,"Procedural Texture Refresh Interval", 74, hw->pref.lmInterval, 0,1);
			//dialog->control(SLIDER,"[] Size",               53, hw->pref.bracket, .1,6);
			//dialog->control(SLIDER,"PageUp/Dn: Ground Height", 54, hw->pref.page, .1,4);
			//dialog->control(SLIDER,"<> Tesselation: Mesh",     50, hw->pref.tess, 10,50,1,1);
			//dialog->control(SLIDER,"6",   306, hw->pref.value[6], .1,10);
			//dialog->control(SLIDER,"7",   307, hw->pref.value[7], .1,10);
			//dialog->control(SLIDER,"8",   308, hw->pref.value[8], .1,10);
			//dialog->control(SLIDER,"9",   309, hw->pref.value[9], .1,10);

//-----------------------------------------------------------------------------

void dialog_do(void) {
	float value;
	static float last0=1,last1=1;
	static int lastoption=-1;
	
	value=dialog->activeValue;
	if (dialog->activeID==93) { // back
		if (dialog->ID==MAIN) {
			dialog->off();
			return;
		} else {
			float ox=dialog->ox;
			float oy=dialog->oy;
			dialog->pop();
			dialog->ox=ox;
			dialog->oy=oy;
			return;
		}
	}
	else if (dialog->activeID==99) { // exit app
		dialog->off();
		//hw->sound.stop_sound();
		//hw->sound.play2d("sounds/comeagain.wav");
		hw->ex=hw->time.time;
		hw->screen.set_dim(DIMON, 2, 0,0,0,1); // fade 0->full, over 2 sec, in black
		hw->screen.capture=1; hw->pref.blank=0; hw->pref.c2=.2;
		hw->pref.user=1;
		return;
	}
	if (dialog->ID!=THISAPP) {
		dialog->dialog_do_standard();
		return;
	}
	//--------------------------------------------------------
	switch(dialog->ID) {
		case THISAPP:
		switch(dialog->activeID) {
			case 41: if (hw->pref.option!=(int)value) hw->pref.option=value;
				break;

			case 201: hw->pref.demosequence =value; hw->ann->hold_multi((int)value,"Demo Off","Demo On"); break;
			case 207: hw->pref.viewportset=value; hw->screen.set_nviewports(hw->pref.viewportset); break;
			case 204:
				hw->pref.colorMode=value;
				ann.hold_multi(hw->pref.colorMode,"RGB","Sepia","BlueGreen","NightVision","InverseColor","B&W");
				if (hw->pref.colorMode==5) Texture::globalBlendMode=GL_BLEND;
				else                       Texture::globalBlendMode=0;
				if (hw->pref.colorMode==3) {
					hw->screen.lightmap.on=1;
					hw->screen.lightmap.ampl=50;
					hw->screen.lightmap.type=36;
					hw->screen.lightmap.texmagx=.5;
					hw->screen.lightmap.texmagy=2;
				} else hw->screen.lightmap.on=0;
				break;

			case 300: hw->pref.value[0]=value; hw->ann->hold("0: %4.2f",value); break;
			case 301: hw->pref.value[1]=value; hw->ann->hold("1: %4.2f",value); break;
			case 302: hw->pref.value[2]=value; hw->ann->hold("2: %4.2f",value); break;
			case 303: hw->pref.value[3]=value; hw->ann->hold("3: %4.2f",value); break;
			case 304: hw->pref.value[4]=value; hw->ann->hold("4: %4.2f",value); break;
			case 305: hw->pref.value[5]=value; hw->ann->hold("5: %4.2f",value); break;
			case 306: hw->pref.value[6]=value; hw->ann->hold("6: %4.2f",value); break;
			case 307: hw->pref.value[7]=value; hw->ann->hold("7: %4.2f",value); break;
			case 308: hw->pref.value[8]=value; hw->ann->hold("8: %4.2f",value); break;
			case 309: hw->pref.value[9]=value; hw->ann->hold("9: %4.2f",value); break;
			case 310: hw->pref.value[10]=value; hw->ann->hold("10: %4.2f",value); break;

			case 311: hw->pref.value[11]=value; hw->ann->hold("11: %4.2f",value); break;
			case 312: hw->pref.value[12]=value; hw->ann->hold("12: %4.2f",value); break;
			case 313: hw->pref.value[13]=value; hw->ann->hold("13: %4.2f",value); break;
			case 314: hw->pref.value[14]=value; hw->ann->hold("14: %4.2f",value); break;
			case 315: hw->pref.value[15]=value; hw->ann->hold("15: %4.2f",value); break;
			case 316: hw->pref.value[16]=value; hw->ann->hold("16: %4.2f",value); break;
			case 317: hw->pref.value[17]=value; hw->ann->hold("17: %4.2f",value); break;
			case 318: hw->pref.value[18]=value; hw->ann->hold("18: %4.2f",value); break;/////////////
			case 319: hw->pref.value[19]=value; hw->ann->hold("19: %4.2f",value); break;

			case 501: hw->pref.tessf=value; hw->ann->hold("Tesselation Factor: %.2f",value); break;
		}
	}
}
/*
			case 106: hw->pref.gruntMPS   =value; hw->ann->hold("Grunt MPS: %4.2f",value); break;
			case 50:  hw->pref.tess         =value; hw->ann->hold("Tesselation:: %d",(int)value); break;
			case 54:  hw->pref.page         =value; hw->ann->hold("<PageUp/Down> Height: %4.2f",value); break;
			case 42: hw->pref.universe=value; break;
			case 53: hw->pref.bracket =value; hw->ann->hold("Size: %4.2f",value); break;
			case 80: hw->pref.n       =value; hw->ann->hold("#: %d", (int)value); break;
*/

//--------------------------------------------------------------------

