#if !defined disp_h
#define      disp_h

//#include "main.h"
#include "vector.h"
#include "place.h"
#include "vis.h"
#include "material.h"
#include "texattrib.h"

//---------------------------------------------------------
class Physics;
class Vector;

class BaseObject{
public:		BaseObject(){};
	virtual ~BaseObject(){};

	virtual void draw(float size){};
	virtual int collide(Place *place, Physics *physics){return 0;};
};

//-----------------------------------------------------------------
class BaseObject;

class DispObj{ // object package w/ obj ptr, attr & vis
public: DispObj();
	virtual ~DispObj();

	BaseObject  *object;
	Vis   vis;
	Place place;
	Material material;
	TexAttrib texattribs[5];
	char label[20];

	virtual void draw(float size);
};

//-------------------------------------------------------------------

#define MAXDISPLAYOBJECTS 30

class DispMan{
public: DispMan();
	virtual ~DispMan();

	int nobjects, selObject;
	DispObj dos[MAXDISPLAYOBJECTS];
	float sizes[MAXDISPLAYOBJECTS];
	int ons[MAXDISPLAYOBJECTS];

	int add(BaseObject *base);
	void draw(int n);
	void reset(void);
	void unset(void);
	void update(void);
	void pref2object(int i);
};

//-------------------------------------------------------------------


#endif

