//-------------------------------------------------------------------
//	File:		   displaylist.cpp
//-------------------------------------------------------------------

#include "main.h"
#include "displaylist.h"

//-------------------------------------------------------------------

DisplayList::DisplayList() {
	listID=0;
	reuse=0;
	mode=0;
};
DisplayList::~DisplayList() {};

//--------------------------------------------------------------------

void DisplayList::create(int inmode) {
	if ((listID!=0)&&(reuse=0)) destroy();
	if (listID==0) listID=glGenLists(1);
	if (listID==0) return;
	mode=inmode;
	return;
}

//--------------------------------------------------------------------

void DisplayList::open(void) {
	switch(mode) {
		case COMPILE:             glNewList(listID,GL_COMPILE);             break;
		case COMPILE_AND_EXECUTE: glNewList(listID,GL_COMPILE_AND_EXECUTE); break;
	}
}

//--------------------------------------------------------------------

void DisplayList::close(void) {
	glEndList();
}

//--------------------------------------------------------------------

void DisplayList::draw(void) {
	glCallList(listID);
}

//--------------------------------------------------------------------

void DisplayList::destroy(void) {
	char s[50];

	if (listID>0) {
		sprintf(s,"   Destroying mesh display list # %u...",listID);
		log_message(s);
		glDeleteLists(listID,1);
		listID=0;
	}
}

//--------------------------------------------------------------------

