#if !defined effect_h
#define      effect_h

#include "main.h"
#include "bump.h"
#include "disp.h"
#include "fog.h"
#include "mesh.h"
#include "hardware.h"
#include "particle.h"
#include "billboard.h"
#include "physics.h"
#include "texture.h"
#include "d3d.h"
#include "sphere.h"
#include "torus.h"
#include "perlin.h"
#include "lightning.h"

//-----------------------------------------------------------------

class Rays:public BaseObject{
public:     Rays();
	virtual ~Rays();

	struct aray{
		float x,y,z, xi,yi,zi, pitch,heading,roll, pitchi,headingi, rolli, age, depth;
	} uray[300];
	int nrays;

	void draw(float size);
	int collide(Place *place, Physics *physicson);
	void init(void);
};

//---------------------------------------------------------------------------------

class Columns:public BaseObject{
public:     Columns();
	virtual ~Columns();

	DisplayList dl;

	void draw(float size);
	int collide(Place *place, Physics *physicson);
	void init(void);
};

//---------------------------------------------------------------------------------

class Text;

class Effect{
public: Effect();
	virtual ~Effect();

	int nobjects, effectn, neffects, collide, physics, nite;
	float vars[6];
	int soundindex1,soundindex2,soundindex3,songindex;

	Bump bump;
	Billboard bb;
	Mesh groundM, volcanoM, cloud1M, ceilingM, fallM;
	Particle p1P,p2P,p3P;// , fogP;
	Texture imageT[20], *sphereT, lavaT, smokeT, eyeT, tmpT,arcT;
	DispMan dispman;
	Physics generalPH, spacePH, airPH, groundPH;
	Hw *hw;
	Sphere globe1,globe2;
	Torus torus;
	Rays rays;
	Columns columns;
	Perlin perlin;
	Lightning lightning;

#define MAXSCRIPTITEMS 20

	int scriptindex,nscriptitems, totalscenes, newScene, runscript;
	float effectf, lastscenetime;

	struct ascriptitem{
		int time,effectn;
	} scriptitems[MAXSCRIPTITEMS];

	void annot(Text *ann);
	void close(void);
	void draw(Text *ann);
	void init(Text *ann);
	void key(Text *ann);
	void reset(Text *ann);
	void load_data(void);
	void particle_init(void);
	void object2pref(void);
	void set_option(Text *ann);
	void start_frame(Text *ann);
	void end_frame(Text *ann);
	void track_steps(void);
	void test_mesh_zone(Text *ann);
	void doc_selObject(void);
	void effect0(int);
	void effect1(int);
	void effect2(int);
	void effect3(int);
	void effect4(int);
	void effect5(int);
	void effect6(int);
	void proc_effect(int mode);
	int load_shader(const char* infile);
	int load_script(const char *);
	void check_script(void);
	void draw_eye(void);
	void init_script(void);
	void run_script(void);
	void run_auto(void);
	void doc_scene(void);
	void copy_image(int x, int y, Texture *texture);
	void paste_image(int x, int y, float scale, Texture *texture);
};

//---------------------------------------------------------------------------------

#endif