//-------------------------------------------------------------------
//	File:		   histogram.cpp
//	Comments:   by George Ziniewicz
//-------------------------------------------------------------------

#include "histogram.h"

//-------------------------------------------------------------------

Histogram::Histogram() {
	nbins=3;
	startbin=0;
	endbin=1;
	init();
};
Histogram::~Histogram() {};

//-------------------------------------------------------------------

void Histogram::clear_bins(void) {
	for (int i=0; i<MAXBINS; i++) {
		bins[i]=0;
	}
}

//-------------------------------------------------------------------

void Histogram::draw(void) {
	int i;
	float x=100, y=100, posx,posy, sizex=2,sizey=2;

	glColor3f(1,1,0);
	glLineWidth(1);
	glBegin(GL_LINES);
		for (i=0; i<nbins; i++) {
			posx=x+     i *sizex;
			posy=y+bins[i]*sizey;
			glVertex2f(posx,   y);
			glVertex2f(posx,posy);
		}
		glEnd();
	glLineWidth(2);
}

//-------------------------------------------------------------------

void Histogram::init(void) {
	nentries=0;
	binrange=endbin-startbin;
	binsize=binrange/(nbins-1);
	binoffset=.5*binsize;
	clear_bins();
}

//-------------------------------------------------------------------

void Histogram::insert(float value) {
	bins[value2index(value)]++;
	nentries++;
}

//-------------------------------------------------------------------

int Histogram::value2index(float value) {
	int index;
	float tmp=value-startbin;

	index=(tmp+binoffset)/binsize;
	index=(index<0)?0:(index>=nbins)?nbins-1:index;
	return index;
}

//-------------------------------------------------------------------

