//
#include "lightmap.h"
#include "main.h"
#include "hardware.h"

//------------------------------------------------------------------

Lightmap::Lightmap(){
	type=4; on=0;
	tex.lastUpdateTime=0; updateInterval=.07;
	texmagx=3; texmagy=3;
	ampl=30; size=70;
	blendFunc0=0;
	blendFunc1=6;
};
Lightmap::~Lightmap(){};

//---------------------------------------------------------------------------------------

char *Lightmap::doc(void) {
	static char s[80];
	s[0]=0;

	if (type&1) strcat(s,"X-Film");
	if (type&2) {
		if (s[0]!=0) strcat(s," + ");
		strcat(s,"Y-TV");
	}
	if (type&4) {
		if (s[0]!=0) strcat(s," + ");
		strcat(s,"Z-Spot");
	}
	if (type&8) {
		if (s[0]!=0) strcat(s," + ");
		strcat(s,"Vignette");
	}
	if (type&16) {
		if (s[0]!=0) strcat(s," + ");
		strcat(s,"X-Grating");
	}
	if (type&32) {
		if (s[0]!=0) strcat(s," + ");
		strcat(s,"Y-Grating");
	}
	return s;
}

//---------------------------------------------------------------------------------------

void Lightmap::draw(void) {
	if ((type==0)||(!on)) return;
	Hw *hw=Hw::get();

	set_blend(blendFunc0,blendFunc1);
	glEnable(GL_BLEND);
	glColor4f(r,g,b,a);
	glDisable(GL_DEPTH_TEST);
	glDepthMask(GL_FALSE);
	tex.bind();
	glEnable(GL_TEXTURE_2D);
	glPushAttrib(GL_POLYGON_MODE);
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
		glBegin(GL_QUADS);
			glTexCoord2f(      0,      0); glVertex2f(               0,                0);
			glTexCoord2f(texmagx,      0); glVertex2f(hw->screen.width,                0);
			glTexCoord2f(texmagx,texmagy); glVertex2f(hw->screen.width,hw->screen.height);
			glTexCoord2f(      0,texmagy); glVertex2f(               0,hw->screen.height);
			glEnd();
		glPopAttrib();
	glDisable(GL_BLEND);
	glDepthMask(GL_TRUE);
	glDisable(GL_TEXTURE_2D);
	Hw::get()->ntris+=2;
}

//---------------------------------------------------------------------------------------

void Lightmap::update(void) {
	if (((Hw::get()->time.time-tex.lastUpdateTime)>updateInterval)&&(type!=0)&&on){
		tex.lastUpdateTime=Hw::get()->time.time;
		tex.lightmap(type,ampl,size);
	}
}

//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------

