//

#include "material.h"

Material::Material() {
	on=0;
	ambient=.25; diffuse=.5; specular=.75; reflective=1;
	shininess=25; exponent=1; cutoff=180;
	r=g=b=1;
};

Material::~Material() {};

//---------------------------------------------------------------------------

void Material::set(void) {
   int i, lightn=0;
   int linfo[]={GL_LIGHT0,GL_LIGHT1,GL_LIGHT2,GL_LIGHT3,
                GL_LIGHT4,GL_LIGHT5,GL_LIGHT6,GL_LIGHT7};
	GLfloat amba[4]={0,0,0,1.}, diffa[4]={0,0,0,1.},
		    speca[4]={0,0,0,1.}, refla[4]={0,0,0,1.};
	float color[3];

	color[0]=r;
	color[1]=g;
	color[2]=b;

	if (on) {
		for (i=0; i<3; i++) {
			 amba[i]= ambient *color[i]; diffa[i]= diffuse   *color[i]; 
			speca[i]= specular*color[i]; refla[i]= reflective*color[i];
		}

		glMaterialfv(  GL_FRONT_AND_BACK,GL_SPECULAR,refla);

		glLightModelfv(GL_LIGHT_MODEL_AMBIENT,amba);
		glLightfv(linfo[lightn],GL_AMBIENT, amba);
		glLightfv(linfo[lightn],GL_DIFFUSE, diffa);
		glLightfv(linfo[lightn],GL_SPECULAR,speca);
		glLightf( linfo[lightn],GL_SPOT_EXPONENT,exponent);
		glLightf( linfo[lightn],GL_SPOT_CUTOFF,cutoff);
		glMateriali(GL_FRONT_AND_BACK,GL_SHININESS,shininess);//5bigspot-50smallspot
	}
}

//---------------------------------------------------------------------------
