//

#include "mouse.h"
#include "hardware.h"

//------------------------------------------------------------------------

Mouse::Mouse(){
	warpx=400; warpy=400; ydir=1;
	reset();
};
Mouse::~Mouse(){};

//------------------------------------------------------------------------

void Mouse::reset(void){
	x=lastx=warpx;
	y=lasty=warpy;
	xi=yi=alt=control=shift=moved=0;
	for (int i=0;i<3;i++ ) {
		button[i]=0;
		lastdowntime[i]=0;
		lastdowndt[i]=0;
	}
}

//------------------------------------------------------------------------

void Mouse::set_pos(int inx, int iny){
	lastx=x;
	lasty=y;
	x=inx;
	y=iny;
	xi=x-lastx;
	yi=y-lasty;
	moved=1;
}

//------------------------------------------------------------------------

void Mouse::set_button(int inbutton, int state, int mod){
	int i=-1;
	switch(inbutton) {
		case GLUT_LEFT_BUTTON:   i=0; break;
		case GLUT_MIDDLE_BUTTON: i=1; break;
		case GLUT_RIGHT_BUTTON:  i=2; break;
	}
	if (i>=0) {
		if ((state==GLUT_DOWN)&&(button[i]==0)) {
			lastdowndt[i]=Hw::get()->time.realTime-lastdowntime[i];
			lastdowntime[i]+=lastdowndt[i];
		}
		if      ((state==GLUT_DOWN)&&(button[i]==0)) button[i]=1;
		else if ((state==GLUT_UP)  &&(button[i]==2)) button[i]=3;
	}
	set_modifiers(mod);
}

//------------------------------------------------------------------------

void Mouse::set_modifiers(int mod) {
	alt    =(mod&GLUT_ACTIVE_ALT)  ?1:0;
	shift  =(mod&GLUT_ACTIVE_SHIFT)?1:0;
	control=(mod&GLUT_ACTIVE_CTRL) ?1:0;
}

//------------------------------------------------------------------------

void Mouse::sequence(void){
	moved=0;
	for(int i=0;i<3;i++){
		if      (button[i]==1) button[i]=2;
		else if (button[i]==3) button[i]=0;
	}
	warp();
}

//------------------------------------------------------------------------

void Mouse::warp(void){
	if ((Hw::get()->pref.fullscreen)&&(Hw::get()->dialogs==0)) {
		x=lastx=warpx;
		y=lasty=warpy;
		xi=0; yi=0;
		glutWarpPointer(warpx,warpy);
	}
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

void Mouse::set_cursor(void) {
	//if ((hw->pref->dialogs)||((hw->pref->fullscreen==0)&&(hw->pref->view==0))) 
	if ((Hw::get()->dialogs)||
		 (Hw::get()->pref.fullscreen==0)) glutSetCursor(GLUT_CURSOR_LEFT_ARROW);
	else                                 glutSetCursor(GLUT_CURSOR_NONE);
	return;
}

//---------------------------------------------------------------------------

