//
#include "perlin.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

Perlin::Perlin() {
	for (int i=0; i<MAXENTRIES; i++) data[i]=rndn(1);
};
Perlin::~Perlin() {};

//-----------------------------------------------------------------------------------
/*

float Perlin::get1(int channel, float value) {
	int valuei=value;
	int n =((int)( valuei   *(channel+1)))%MAXENTRIES,
		 n2=((int)((valuei+1)*(channel+1)))%MAXENTRIES;

	return cos_interp(data[n],data[n2],frac(value));
}

//-----------------------------------------------------------------------------------

float Perlin::get(int channel, float value) {
	int valuei=value;
	int n =((int)( valuei   *(channel+1)))%MAXENTRIES,
		 n2=((int)((valuei+1)*(channel+1)))%MAXENTRIES;

	return cos_interp(data[n],data[n2],frac(value))*2-1;
}
*/

//-----------------------------------------------------------------------------------

#define MAXN 9
float Perlin::get1(int channel, float value) {
	int valuei=value, channelbank=channel/MAXN;
	float f=value-valuei, ch[MAXN]={1,2.2,3,4.2,5.5,6.2,7,8.2,9};
	int n1,n2;
	
	n1=(valuei+  pow(channelbank,2))*ch[channel%MAXN];
	n2=(valuei+1+pow(channelbank,2))*ch[channel%MAXN];

	n1 %= MAXENTRIES;
	n2 %= MAXENTRIES;

	return cos_interp(data[n1],data[n2],f);
}

//-----------------------------------------------------------------------------------

float Perlin::get(int channel, float value) {
	return get1(channel,value)*2-1;
}
//-----------------------------------------------------------------------------------

