//

#include "pref.h"
#include "text.h"
#include "place.h"
#include "hardware.h"

//-------------------------------------------------------------------

Pref::Pref() {
	reset();
};
Pref::~Pref() {};

//-------------------------------------------------------------------

void Pref::reset(void) {
	arrowx=1; arrowy=1; // adjusters
	bracket=1;	brace=0;	home=1; page=1; paren=1;
	mouseSens=1;	moveSens=1;	
	spd1=1;	spd2=1;
	a1=1;	a2=1;
	b1=1;	b2=10;
	c1=1;	c2=.5;

	blank=1; // toggles/enables
	clock=0;
	fog=1;
	fullscreen=1;
	scrollInfo=1;
	lights=1;
	textures=1;
	user=0;
 // int control flags
	colorMode=0;
	option=0;
	m=0;
	n=0;//13;
	tess=10;
	universe=1;
	viewportset=1;
	wireframe=0;
	windowWidth =400;	windowHeight=400;
	useSoundDriver=-1; // use default highest sound driver

	// float controls
	letterbox=.12;
	lastsoundtime=0;
	doubleClickInterval=.33;
	nstars=500;
	annotateDuration=3;
	scrollSpeed=1;
	minSoundInterval=4;
	maxSoundInterval=20;
	scrollInterval=30;
	stepVolume=.5;
	stepPan=.15;
	spurt=160;
	gruntMPS=32;
	//skipSplash=0;
	gravityScaler=2;
	dragScaler=1;
	//movemode=MANUAL;
	for (int i=0; i<20; i++) {
		value[i]=1;
		toggle[i]=0;
	}
	demosequence=1;
	ambientvolume=.33;
	sceneduration=25;
	songvolume=.5;
	tessf=1;
	randseed=23;

	// vis edit
	alphafunc=.05;
	blendFunc0=2; blendFunc1=3;
	r=g=b=a=1;
	seltexlayer=0;

	// tex edit
	image=0;
	texmagx=texmagy=1;
	texoffx=texoffy=0;
	texBlendFunc0=1,texBlendFunc1=1;

	// mat edit
	ambient=.45;	diffuse=.6;	specular=.85;	reflective=.99;
	exponent=1;	cutoff=180;	shininess=20;
	mat_r=mat_g=mat_b=1;
}

//-------------------------------------------------------------------

int Pref::load(const char* title) {
	char s[80];
	
	strcpy(s,title);
	strcat(s,".pref");
	ifstream file(s,ios::binary|ios::nocreate);
	if (file.bad()||(file==0)) return 1;
	file.read((char *) this, sizeof(Pref));
	file.close();
	return 0;
}

//-----------------------------------------------------------------------------------

int Pref::save(const char* title) {
	char s[80];

	strcpy(s,title);
	strcat(s,".pref");
	ofstream file(s,ios::binary|ios::out);
	if (file.bad()||(file==0)) return 1;
	file.write((char *) this, sizeof(Pref));
	file.close();
	return 0;
}

//----------------------------------------------------------------------------------

void Pref::set(const char *title) {
	if (load(title)==0) {
		log_message("Loaded Prefs.");
		Hw::get()->ann->hold("Auto-Loaded Prefs");
	} else {
		reset();
		log_message("No Prefs found.");
		Hw::get()->ann->hold("Default Prefs");
	}
}

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

