#if !defined screen_h
#define      screen_h

#include "lightmap.h"
#include "main.h"
#include "viewport.h"
#include "splinter.h"

//-----------------------------------------------------------------------------

enum dimtypes {DIMOFF,DIMON,DIMA,DIMV};

class Lightmap;
class Viewport;

class Screen{
public: Screen();
	virtual ~Screen();

	int windowID, width,height, windowWidth,windowHeight, fullscreen, needblank, capture;
	int viewportn, viewportset, nviewports, currentViewport;
	float windowAspect, nearz, farz, r,g,b,a;

	float dimdir, dimtime, dimduration, dimr,dimg,dimb,dima;

	int letterboxHeight,letterboxBottom;
	float letterbox;

	Lightmap lightmap;
	Viewport viewports[8], *viewport;
	Splinter splinter;

	void bound_cameras(float mx, float my);
	void clear(void);
	void clear_letterbox(void);
	void draw_dim(void);
	void fade(void);
	void init(void);
	void load_viewport(float array2[][4], int n);
	void rect(void);
	void reset(void);
	void set_dim(float indir, float induration, float inr, float ing, float inb, float ina);
	void set_nviewports(int n);
	void setup(void);
	void set_letterbox(void);
	void set_ortho(void);
	void set_perspective(void);
	void set_screen(void);
	void doc_letterbox(void);
	void set_color(float inr,float ing,float inb);
	void set_color(float inr,float ing,float inb, float ina);
};

//-----------------------------------------------------------------------------

#endif


