// skybox.cpp

#include "skybox.h"
#include "hardware.h"

//-------------------------------------------------------------------------------

Skybox::Skybox(){
	canCull=0;
	gap=1.4;
}

Skybox::~Skybox(){
}

//-------------------------------------------------------------------------------

void Skybox::init(void) {
	log_message("Init skybox...");
	sb0.repeatMode=GL_CLAMP;
	sb1.repeatMode=GL_CLAMP;
	sb2.repeatMode=GL_CLAMP;
	sb3.repeatMode=GL_CLAMP;
	sbt.repeatMode=GL_CLAMP;
	sbb.repeatMode=GL_CLAMP;
	sb0.load_tex("images/ff.bmp", GL_RGBA,-1,0, 0);//f
	sb1.load_tex("images/fr.bmp", GL_RGBA,-1,0, 0);
	sb2.load_tex("images/fb.bmp", GL_RGBA,-1,0, 0);
	sb3.load_tex("images/fl.bmp", GL_RGBA,-1,0, 0);
	sbt.load_tex("images/ft.bmp", GL_RGBA,-1,0, 0);
	sbb.load_tex("images/f0.bmp", GL_RGBA,-1,0, 0);
}

//-------------------------------------------------------------------------------

void Skybox::draw(void) {
	int face;
	float sizeh=size*.5;

	if (canCull) {
		face=(Hw::get()->screen.viewport->camera.place.orient.y+45) / 90; // cull behind panel
		if ( (Hw::get()->screen.viewport->camera.place.orient.x> 30) &&
			  (Hw::get()->screen.viewport->camera.place.orient.x<330)) face=-1;
	}
	else face=-1;
	zColor3f(r,g,b);
	glEnable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);
	glPushMatrix();
		glTranslatef(x,y,z);
		if (face!=0) draw1(&sb2, sizeh,      0,     0,  sizeh, 180,0,1);
		if (face!=1) draw1(&sb1, sizeh,  sizeh,     0,      0, 270,0,1);
		if (face!=2) draw1(&sb0, sizeh,      0,     0, -sizeh,   0,0,1);
		if (face!=3) draw1(&sb3, sizeh, -sizeh,     0,      0,  90,0,1);
		             draw1(&sbt, sizeh,      0, sizeh,      0,  90,1,0);
		             draw1(&sbb, sizeh,      0,-sizeh,      0, -90,1,0);
		glPopMatrix();
	glDisable(GL_CULL_FACE);
	glDisable(GL_TEXTURE_2D);
	return;
}


//-------------------------------------------------------------------------------

void Skybox::draw1(Texture *tex, float size, float tx, float ty, float tz,
				                                 float r,  float rx, float ry) {
	glPushMatrix();
		glTranslatef(tx,ty,tz);
		glRotatef(r,rx,ry,0);
		tex->bind();
		glBegin(GL_QUADS);
			glTexCoord2f(0,0); glVertex2f(-size,-size);
			glTexCoord2f(1,0); glVertex2f( size,-size);
			glTexCoord2f(1,1); glVertex2f( size, size);
			glTexCoord2f(0,1); glVertex2f(-size, size);
			glEnd();
		glPopMatrix();
	Hw::get()->ntris+=2;
	return;
}

//-------------------------------------------------------------------------------



