#if !defined sound_h
#define      sound_h

#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <math.h>

#include "fmod.h"
#include "fmod_errors.h"
#include "main.h"

class Hw;

//---------------------------------------------------------------------------------

#define MAXSAMPLES 20

class Text;

class Sound{
public:		Sound();
	virtual ~Sound();

	char s[80];
	int inited, numDrivers, on, soundDriver, soundOutput, type, verbosity, playex;
	int lastChannel, sampleChannel;
	int hasEAX, hasHw, reverbMode,pause;
	float x,y,z, volume_master, pan, mindistance, maxdistance, rolloff;
	FSOUND_SAMPLE *sample;
	Hw *hw;

	struct asample{
		FSOUND_SAMPLE *sample;
		int channel;
	} samples[MAXSAMPLES];
	int nsamples, samplen;

	void close(void);
	int  finish_2d(FSOUND_SAMPLE *sample);
	int  finish_3d(FSOUND_SAMPLE *sample, float x, float y, float z);
	void free_sample(FSOUND_SAMPLE *sample);
	int  get_channels_playing(void);
	int   get_frequency(int channel);
	float get_volume(int channel);
	int init(void);
	FSOUND_SAMPLE *load_wav(const char *s);
	void log_error(void);
	void set_pause(int pause);
	void set_pause(int pause,int channel);
	int play(const char *s);
	int play2d(const char *s);
	int play_type(const char * ins, int type);
	int play(const char *s,float x, float y, float z);
	int play(FSOUND_SAMPLE *sample);
	int play(FSOUND_SAMPLE *sample,float x, float y, float z);
	void set_frequency(int infrequency);
	void set_loop(FSOUND_SAMPLE *sample);
	void set_master_volume(float involume);
	void set_pan(float inpan);
	void set_position(int channel, float x, float y, float z);
	void set_reverb(int envn, Text *ann);
	void set_rolloff(float value);
	void set_volume(float volume);
	void stop_sound(void);
	void update_listener(void);
	void update_listener(float x,float y,float z,float fx,float fy,float fz,float ux,float uy,float uz);
	void set_reserved(void);
	void set_surround(void);
	int get_free_sample(void);
	int place_loop(const char * ins, float x, float y, float z);

	FSOUND_GEOMLIST *glist;
	FSOUND_MATERIAL *material;

	int  open_geom(void);
	void close_geom(void);
	void make_geom_polys(void);

	//int on_music;
	//float volume_music;
	//FMUSIC_MODULE *mod;
	/*FMUSIC_MODULE *load_song(char *s);
	void set_music_volume(FMUSIC_MODULE *mod, float value);
	void stop_music(FMUSIC_MODULE *mod);
	void play_music(FMUSIC_MODULE *mod);
	void free_song(FMUSIC_MODULE *mod);
	int music_finished(FMUSIC_MODULE *mod);
	*/
};

//-------------------------------------------------------------------------------
/*
class SoundObj{
public:		SoundObj();
	virtual ~SoundObj();

	FSOUND_SAMPLE *sample;

	char name[80];
	int on, type, loop;
	float volume, pan;
	Vector pos, orient;
};
*/
#endif


