//
#include "sphere.h"
#include "hardware.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

Sphere::Sphere(){
	size=0; // if 0 use draw(size)
	tessx=tessy=10;
	tessdistmin=50;  mindisttess=40; // close up
	tessdistmax=200; maxdisttess=10; // faraway
	tessdist=0;
};
Sphere::~Sphere(){};

//----------------------------------------------------------------------------

void Sphere::draw(float insize){
	int tess=tessx;
	float f, fsize;

	if (size==0) fsize=insize;
	else         fsize=size;

	if (tessdist!=0) {
		f=1-((tessdist-tessdistmin) / (tessdistmax-tessdistmin)); // inverse dist
		f=clampf(f,0,1);                                        // clip 1->0
		f=pow(f,2);                                             // exp curve 
		tess=lin_interp(maxdisttess,mindisttess,f);             // interp tess
	}
	solid_sphere(fsize,tess,tess);
	Hw::get()->ntris+=tess*(tess-1)*2;
}

//----------------------------------------------------------------------------

int Sphere::collide(Place *place, Physics *physicson){return 0;};

//----------------------------------------------------------------------------

void Sphere::init(void){};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

void solid_sphere(float size, int tesx, int tesy) {
	int aix, ix,iy, iy2;
	float rx,ry, cx, cy,cy2, dx,dy,dz, dx2,dy2,dz2;
	float fx,fy,fy2, texx, texy, texy2;
	if ((tesx<  3)||(tesy<  3)) return;
	if ((tesx>100)||(tesy>100)) return;
	rx=pi2 /  tesx;
	ry=pi1 / (tesy-1);

	for    (iy=0; iy<(tesy-1); iy++) {
		iy2=iy+1;
		fy =iy*ry;
		fy2=iy2*ry;
		dy = -cosf(fy );
		dy2= -cosf(fy2);
		cy =(float)iy  / tesy;
		cy2=(float)iy2 / tesy;
		texy =cy;
		texy2=cy2;
		glBegin(GL_TRIANGLE_STRIP);
			for (ix=0; ix<=tesx; ix++) {
				cx=(float)ix / tesx;
				aix=(ix==tesx) ? 0 : ix;
				fx=aix*rx;
				dx =sinf(fx)*sinf(fy);  dz =cosf(fx)*sinf(fy);
            dx2=sinf(fx)*sinf(fy2); dz2=cosf(fx)*sinf(fy2);
				texx=cx;
				glNormal3f(dx2,dy2,dz2); glTexCoord2f(texx, texy2+cx); glVertex3f(dx2*size, dy2*size, dz2*size);
				glNormal3f(dx ,dy ,dz);  glTexCoord2f(texx, texy +cx); glVertex3f(dx *size, dy *size, dz *size);
			}
			glEnd();
	}
	Hw::get()->ntris+=(tesx*tesy)*2;
}

//------------------------------------------------------------------------------

