#if !defined texture_h
#define      texture_h

#include "main.h"

//---------------------------------------------------------------------------------

enum procnames {SPHERE, NOTSPHERE, GRADIENT, SMOKE, HALO, STAR, SAND, BLANK, SPARK};

#define MAXTEXTURE 30

class Texture{
public:     Texture();
	virtual ~Texture();

	static GLuint lastTexID, globalBlendMode;
	static float  envr,envg,envb, enva;
	static int ntextures;
	static Texture *textures[MAXTEXTURE+1];
	static char names[MAXTEXTURE+1][80];
	float lastUpdateTime;

	GLuint texID, type, repeatMode, blendMode;
	int    sizex,sizey, smokeiteration,smokesize, imagen;
	
	void bind(void);
	static void close(void);
	int  load_tex(const char *picname, GLenum intype, int alpha, int threshold, int mipmap);
	int make_tex(int type, int sx, int sy, GLenum intype, int mipmap);
	void mip(int mipmap);
	void lightmap(int lightmap, int grain, int insize);
};

//---------------------------------------------------------------------------------

#endif