//

#include "time.h"
#include "utility.h"
#include "hardware.h"

//------------------------------------------------------------------------

Time::Time(){
	reset();
};
Time::~Time(){};

//------------------------------------------------------------------------

void Time::reset(void){
	msTime=fps=time=dt=realTime=lastTime=spd1=spd2=offset=0;
	scale=1;
}

//------------------------------------------------------------------------

void Time::sequence(void){
	static int nframes=0;
	static float lastFpsTime=0;

	lastTime=time;
	msTime=get_time();//glutGet(GLUT_ELAPSED_TIME);
	realTime=msTime*.001;
	time=realTime*scale+offset; // global timescale;
	dt=time-lastTime;
	spd1+=dt*Hw::get()->pref.spd1;
	spd2+=dt*Hw::get()->pref.spd2;
	nframes+=1;
	if (realTime>(lastFpsTime+1)) {
		fps=nframes;
		nframes=0;
		lastFpsTime=realTime;
		//fpsn++;
		//fpsSum+=fps;
		//fpsAve=fpsSum/fpsn;
	}
}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//----------------------------------------------------------------------

