#if !defined utility_h
#define      utility_h

#include "main.h"

//----------------------------------------------------------------------

class Camera;
class Pref;
class Vector;

float cos_interp(float a, float b, float x); // math
float lin_interp(float a, float b, float x);
float clampf(float value, float min, float max);
int   clampi(int value, int min, int max);
float frac(float f);
float length(Vector v);
float maxf(float value0, float value1);
int   maxi(int value0, int value1);
float minf(float value0, float value1);
int   mini(int value0, int value1);
float rndn(float range);
int   rndi(int range);
float rnd_gaussian(float size);
float rndnn(int n);
void rotx(float *inx, float *iny, float *inz, float degrees);
void roty(float *inx, float *iny, float *inz, float degrees);
void rotz(float *inx, float *iny, float *inz, float degrees);
float sin1(float angle);
int   sign(float value);
void  v2matrix(Vector forward);
float wrap(float x, float min, float max);
float xy2r(float x,float y);

void delay(int milliseconds); // hardware/utility/misc
int  get_time(void);
int  log_message(char *ins);
void matmult(Camera *camera, float *inx, float *iny, float *inz);
void noop(void);
void zLookAt(Vector *from, Vector *to, float *pitch, float *heading);

char *doc_blend(void); // graphic
void  draw_billboard(float size);
void  draw_frame(float x0, float y0, float x1, float y1, float thick);
void guage(char *s, char *s2, float x, float y, float value, float range);
void  set_blend(int blend0, int blend1);
void  set_polymode(Pref *pref);
void  solid_sphere(float size, int tesx, int tesy,
				       float texmagx, float texmagy,
				       float texoffx, float texoffy);
void tex_gen(int map, int mode);
void zColor3f(float r, float g, float b);
void zColor4f(float r, float g, float b, float a);

void rotate_axes(Vector *a, Vector *b, float angle);
char *doc_universe(void);

void init_multitexture(void);
int isInString(char *string, const char *search);

//----------------------------------------------------------------------

#endif