#include "viewport.h"

#include "main.h"

//--------------------------------------------------------

Viewport::Viewport(){
	viewportAspect=1; useAspect=1;
	reset();
};
Viewport::~Viewport(){};

//------------------------------------------------------------------------

void Viewport::frame(void) {
	zColor3f(.5,.5,0);
	draw_frame(0,0,iwidth,iheight,2);
}

//------------------------------------------------------------------------

void Viewport::reset(void) {
	set_view_pct(0,0,1,1);
	size_viewport(400,400,0);
}

//------------------------------------------------------------------------

void Viewport::set_view_pct(float l, float b, float r, float t) {
	left  =l;
	bottom=b;
	right =r;
	top   =t;
}

//------------------------------------------------------------------------

void Viewport::size_viewport(int inwidth, int inheight, int inbottom) {
	ileft  =left  *inwidth;
	iright =right *inwidth;
	ibottom=bottom*inheight+inbottom;
	itop   =top   *inheight+inbottom;
	iwidth =iright-ileft;
	iheight=itop  -ibottom;
	if (iheight) viewportAspect=(float)iwidth / iheight;
	else         viewportAspect=1;
	set_viewport();
}

//------------------------------------------------------------------------

void Viewport::set_viewport(void) {
	glViewport(ileft,ibottom, iwidth,iheight);
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------


